/*	DIAMOND.H
	Author(s): Nick and Ben
	
	The header for the game diamond, contains all the data and
	function prototypes.
*/


//Constants
#define STRING_LENGTH 26
#define ROOMSTRING_LENGTH 255
#define NUMROOMS 30
#define NUMITEMS 33

char inp[STRING_LENGTH];			//The input string
char command[STRING_LENGTH];		//The command inputed
char argument[STRING_LENGTH];		//The argument after the command
char test[2];						//Used in the parser because for some
									//idiotic reason you can't define it
									//locally and still have the parser work.

int curroom;						//The room we're currently in
bool gamecontinue;					//Flag used to end the game loop
bool movecount;						//counter used in the move function

struct roomstruct
{
	char desc[ROOMSTRING_LENGTH];	//The description of the current room.
	int north;						//These variables contain the room
	int south;						//number of the room in each directoin.
	int east;
	int west;
};
	
//The data for the rooms
roomstruct room[NUMROOMS] = 
{
	"You are standing in Bambi's living room.  To the south is a hallway, to the north is the kitchen, and to the west, the swimming pool", 
	1, 2, 3, -1,
	"You are in the kitchen at Bambi's house.  To the south is the living room, and to the west a door is open slightly.", 
	-1, 0, -1, 7,
	"You are in the hallway.  To the north is the living room, to the east is Bambi's Grandfather's room, and to the west is Bambi's room.",
	0, -1, 5, 4,
	"You out by the swimming pool.  To the west is the living room.",
	-1, -1, -1, 0,
	"You are in Bambi's room.  To the east is the Hallway.",
	-1, -1, 2, -1,
	"You are in Bambi's Grandfather's room.  To the west is the hallway, to the south is a door.",
	-1, 6, -1, 2,
	"You are in the secret stairway.  To the north is Bambi's Grandfather's room, and to the south is another door.",
	5, 8, -1, -1,
	"This is Bambi's garage, filled with small tools and storage items.  To the east is the kitchen.",
	-1, -1, 1, -1,
	"You have entered a secret underground laboratory filled with strange objects.",
	6, -1, -1, -1,
	"The endless desert spans in all directions...",
	10, 9, 9, 9,
	"The endless desert spans in all directions...",
	11, 9, 9, 9,
	"The endless desert spans in all directions...",
	9, 9, 9, 9,
	"You have awoken in a large white room.  There is a strange door to your north.",
	13, -1, -1, -1,
	"You seem to be in some sort of prison. There cell doors to the east and south, and a passage to the north.",
	15, 12, 14, -1,
	"You are in Bambi's cell. The prison is to your west.",
	-1, -1, -1, 13,
	"You are in a short passageway. There is a room to the north, and the prison to the south.",
	16, 13, -1, -1,
	"You are on the main deck of an alien spaceship. The cockpit is to the north, and there are entrances in the other directions.",
	17, 15, 18, 20,
	"The alien at the controls doesn't see you sneak into the cockpit.",
	-1, 16, -1, -1,
	"This room resembles a conference room.  To the east is a greenhouse, to the west is the deck.",
	-1, -1, 19, 16,
	"You are in an alien greenhouse.  There is a huge collection of plants.",
	-1, -1, -1, 18,
	"You are in a circular hall.  The hull is to the east.",
	21, -1, 16, 23,
	"You are in a circular hall.",
	-1, 20, -1, 22,
	"You are in a circular hall.", 
	-1, 23, 21, -1,
	"You are in a circular hall.",
	22, -1, 20, -1,
	"You are on the landing bay surrounded by aliens! There is a door to the north, and the room Bambi is in is to the west.",
	25, -1, -1, 26,
	"You are in the cargo area of the ship. There is a door to the north, a heating duct to the west.",
	28, 24, -1, 27,
	"You sneak into Bambi's holding room.  She is constrained to a torture chair and her grandfather is standing by a control panel.",
	27, -1, 24, -1,
	"You are crawling through the heating duct.",
	-1, 26, 25, -1,
	"You have entered the main control room of the moon base.  There is an escape pod to the north, the cargo bay to the south.",
	29, 25, -1, -1,
	"This is a small escape pod.  The blue earth shimmers in the distance.",
	-1, 28, -1, -1	
};
		
struct itemstruct
{
	char name[STRING_LENGTH];		//Uh... the name of the item.
	int getroom;					//What room it is originally located in.
	int useroom;					//The room you have to use it in.
	bool pickup;					//Whether or not you can pick it up.
	bool inv;						//Whether or not it's in your inventory
	bool used;						//Whether or not it's been used
};

//The data for the items
itemstruct item[NUMITEMS] =
{
	//Name, Location, Where to Use, Mobile, Inv., Whether it's used
	"Statuette", 1, 0, 0, 0, 0,
	"Picture of Bambi", 2, 2, 0, 0, 0,
	"Calculator", 4, 16, 1, 0, 0,
	"Cigarette Lighter", 3, 0, 1, 0, 0,
	"Tiny Screwdriver", 7, 6, 1, 0, 0,
	"Strange Machine", 8, 8, 0, 0, 0,
	"Lever on the wall", 8, 8, 0, 0, 0,
	"Laptop computer", 8, 8, 0, 0, 0,
	"Communicator", 8, 11, 1, 0, 0,
	"Translator", 8, 0, 1, 0, 0,
	"Cactus", 10, 0, 0, 0, 0,
	"Pyramid-shaped rock", 11, 0, 1, 0, 0,
	"Control Panel", 12, 12, 0, 0, 0,
	"Small round window", 15, 15, 0, 0, 0,
	"Intergalactic map", 16, 16, 0, 0, 0,
	"Alien pilot", 17, 0, 0, 0, 0,
	"Flight controls", 17, 17, 0, 0, 0,
	"Alien documents", 18, 18, 0, 0, 0,
	"Vial", 19, 0, 1, 0, 0, 
	"Battery", 20, 0, 1, 0, 0,
	"Ray Gun", 22, 17, 1, 0, 0,
	"Technical Manual", 21, 21, 0, 0, 0,
	"Diamond Necklace", 14, 0, 1, 0, 0, 
	"Military Plans", 23, 23, 0, 0, 0,
	"Blue Key Card", 22, 13, 1, 0, 0,
	"Window", 25, 25, 0, 0 ,0,
	"Diamond-shaped button", 26, 26, 0, 0, 0,
	"Circle-shaped button", 26, 26, 0, 0, 0,
	"Heating duct", 25, 0, 0, 0, 0,
	"Base Controls", 28, 28, 0, 0, 0,
	"Square-shaped button", 26, 26, 0, 0, 0,
	"Alien Dagger", 25, 26, 1, 0, 0,
	"Red button", 28, 28, 0, 0, 0
};

//Function prototypes
void IntroScreen ();
void SetupGame ();
void Parse(char[STRING_LENGTH]);
void GetUserInput();
void CallCommand();
void PrintDesc();
void Command_Move ();
void Command_Get ();
void Command_Use ();
void Command_Quit ();
void Command_Inventory ();
